# remirepo/Fedora spec file for php-zendframework-zend-mail
#
# Copyright (c) 2015-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    067248425f285dec0bdb74256a8f67f9092f115e
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-mail
%global php_home     %{_datadir}/php
%global library      Mail
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.9.0
Release:        1%{?dist}
Summary:        Zend Framework %{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 7.1
BuildRequires:  php-ctype
BuildRequires:  php-date
BuildRequires:  php-iconv
BuildRequires:  php-pcre
BuildRequires:  php-spl
# remirepo:1
%if 0%{fedora} >= 27
BuildRequires:  (php-autoloader(%{gh_owner}/zend-loader)         >= 2.5    with php-autoloader(%{gh_owner}/zend-loader)         < 3)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-mime)           >= 2.5    with php-autoloader(%{gh_owner}/zend-mime)           < 3)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7    with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-validator)      >= 2.10.2 with php-autoloader(%{gh_owner}/zend-validator)      < 3)
# remirepo:10
%else
BuildRequires:  php-autoloader(%{gh_owner}/zend-loader)          <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-loader)          >= 2.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-mime)            <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-mime)            >= 2.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)          <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)          >= 2.7
BuildRequires:  php-autoloader(%{gh_owner}/zend-validator)       <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-validator)       >= 2.10.2
%endif
# From composer, "require-dev": {
#        "zendframework/zend-config": "^2.6",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3",
# ignore and allow v3
#        "zendframework/zend-crypt": "^2.6",
#        "phpunit/phpunit": "^6.0.8 || ^5.7.15",
#        "zendframework/zend-coding-standard": "~1.0.0"
# remirepo:1
%if 0%{fedora} >= 27
BuildRequires:  (php-autoloader(%{gh_owner}/zend-config)         >= 2.6    with php-autoloader(%{gh_owner}/zend-config)         < 3)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-servicemanager) >= 2.7.5  with php-autoloader(%{gh_owner}/zend-servicemanager) < 4)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-crypt)          >= 2.6    with php-autoloader(%{gh_owner}/zend-crypt)          < 4)
# remirepo:8
%else
BuildRequires:  php-autoloader(%{gh_owner}/zend-config)          <  3
BuildRequires:  php-autoloader(%{gh_owner}/zend-config)          >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-servicemanager)  <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-servicemanager)  >= 2.7.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-crypt)           <  4
BuildRequires:  php-autoloader(%{gh_owner}/zend-crypt)           >= 2.6
%endif
BuildRequires:  phpunit6
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^7.1",
#        "ext-iconv": "*",
#        "zendframework/zend-loader": "^2.5",
#        "zendframework/zend-mime": "^2.5",
#        "zendframework/zend-stdlib": "^2.7 || ^3.0",
#        "zendframework/zend-validator": "^2.10.2"
Requires:       php(language) >= 7.1
Requires:       php-iconv
%if ! %{bootstrap}
# remirepo:1
%if 0%{fedora} >= 27
Requires:       (php-autoloader(%{gh_owner}/zend-loader)        >= 2.5    with php-autoloader(%{gh_owner}/zend-loader)         < 3)
Requires:       (php-autoloader(%{gh_owner}/zend-mime)          >= 2.5    with php-autoloader(%{gh_owner}/zend-mime)           < 3)
Requires:       (php-autoloader(%{gh_owner}/zend-stdlib)        >= 2.7    with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
Requires:       (php-autoloader(%{gh_owner}/zend-validator)     >= 2.10.2 with php-autoloader(%{gh_owner}/zend-validator)      < 3)
# remirepo:10
%else
Requires:       php-autoloader(%{gh_owner}/zend-loader)         >= 2.5
Requires:       php-autoloader(%{gh_owner}/zend-loader)         <  3
Requires:       php-autoloader(%{gh_owner}/zend-mime)           >= 2.5
Requires:       php-autoloader(%{gh_owner}/zend-mime)           <  3
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         <  4
Requires:       php-autoloader(%{gh_owner}/zend-validator)      >= 2.10.2
Requires:       php-autoloader(%{gh_owner}/zend-validator)      <  3
%endif
# From composer, "suggest": {
#        "ext-intl": "Handle IDN in AddressList hostnames",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3 when using SMTP to deliver messages"
#        "zendframework/zend-crypt": "^2.6",
%if 0%{?fedora} >= 21
Suggests:       php-intl
Suggests:       php-autoloader(%{gh_owner}/zend-servicemanager)
Suggests:       php-autoloader(%{gh_owner}/zend-crypt)
%endif
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.8.0
Requires:       php-ctype
Requires:       php-date
Requires:       php-pcre
Requires:       php-spl

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Zend\Mail provides generalized functionality to compose and send both text
and MIME-compliant multipart email messages. Mail can be sent with Zend\Mail
via the Mail\Transport\Sendmail, Mail\Transport\Smtp or the
Mail\Transport\File transport. Of course, you can also implement your own
transport by implementing the Mail\Transport\TransportInterface.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Loader/autoload.php',
    '%{php_home}/Zend/Mime/autoload.php',
    '%{php_home}/Zend/Stdlib/autoload.php',
    '%{php_home}/Zend/Validator/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/ServiceManager/autoload.php',
    '%{php_home}/Zend/Crypt/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Config/autoload.php',
]);
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmd in php php71 php72; do
  if which $cmd; then
    $cmd %{_bindir}/phpunit6 \
      --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Fri Mar  2 2018 Remi Collet <remi@remirepo.net> - 2.9.0-1
- Update to 2.9.0
- raise dependency on PHP 7.1
- raise dependency on zend-validator 2.10.2
- always use phpunit6
- use range dependencies on F27+

* Tue Dec 12 2017 Remi Collet <remi@remirepo.net> - 2.8.0-4
- switch from zend-loader to fedora/autoloader
- fix FTBFS from Koschei, ignore 1 test, reported as
  https://github.com/zendframework/zend-mail/issues/183

* Fri Oct 20 2017 Remi Collet <remi@remirepo.net> - 2.8.0-3
- fix FTBFS from Koschei
- add patch for latest PHPUnit from
  https://github.com/zendframework/zend-mail/pull/174

* Fri Jun  9 2017 Remi Collet <remi@remirepo.net> - 2.8.0-1
- Update to 2.8.0
- raise dependency on PHP 5.6
- use phpunit6 on F26+

* Wed Apr 12 2017 Remi Collet <remi@fedoraproject.org> - 2.7.3-2
- add upstream patch to fix FTBFS (from Koschei)
  https://github.com/zendframework/zend-mail/issues/136

* Wed Feb 15 2017 Remi Collet <remi@fedoraproject.org> - 2.7.3-1
- update to 2.7.3

* Wed Dec 21 2016 Remi Collet <remi@fedoraproject.org> - 2.7.2-1
- update to 2.7.2

* Wed May 11 2016 Remi Collet <remi@fedoraproject.org> - 2.7.1-1
- update to 2.7.1

* Tue Apr 12 2016 Remi Collet <remi@fedoraproject.org> - 2.7.0-1
- update to 2.7.0
- zend-crypt is now optional

* Thu Feb 25 2016 Remi Collet <remi@fedoraproject.org> - 2.6.1-1
- update to 2.6.1

* Fri Feb 19 2016 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- update to 2.6.0
- raise dependency on zend-crypt >= 2.6
- raise dependency on zend-stdlib >= 2.7
- raise dependency on zend-validator >= 2.6

* Fri Sep 11 2015 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- update to 2.5.2
- raise minimum PHP version to 5.5

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- initial package
